diff --git a/src/main/java/net/minecraft/core/item/ItemWandSpawner.java b/src/main/java/net/minecraft/core/item/SpawnerWandItem.java
similarity index 72%
rename from src/main/java/net/minecraft/core/item/ItemWandSpawner.java
rename to src/main/java/net/minecraft/core/item/SpawnerWandItem.java
index f6abf76b3..019446cbd 100644
--- a/src/main/java/net/minecraft/core/item/ItemWandSpawner.java
+++ b/src/main/java/net/minecraft/core/item/SpawnerWandItem.java
@@ -1,29 +1,27 @@
 package net.minecraft.core.item;
 
-import net.minecraft.core.HitResult;
-import net.minecraft.core.block.BlockDispenser;
+import net.minecraft.core.entity.Mob;
+import net.minecraft.core.util.phys.HitResult;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.entity.EntityDispatcher;
-import net.minecraft.core.entity.EntityLiving;
-import net.minecraft.core.entity.player.EntityPlayer;
+import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.player.gamemode.Gamemode;
 import net.minecraft.core.util.helper.MathHelper;
-import net.minecraft.core.util.helper.Side;
-import net.minecraft.core.util.phys.Vec3d;
+import net.minecraft.core.util.phys.Vec3;
 import net.minecraft.core.world.World;
-import net.minecraft.server.entity.player.EntityPlayerMP;
+import net.minecraft.server.entity.player.ServerPlayer;
 
 import java.util.Random;
 
-public class ItemWandSpawner
+public class SpawnerWandItem
     extends Item
     implements IDispensable
 {
-    public ItemWandSpawner(String name, int id) {
-        super(name, id);
+    public SpawnerWandItem(String name, String namespaceId, int id) {
+        super(name, namespaceId, id);
     }
     @Override
-    public ItemStack onUseItem(ItemStack itemstack, World world, EntityPlayer player)
+    public ItemStack onUseItem(ItemStack itemstack, World world, Player player)
     {
         if (player.gamemode != Gamemode.creative){
             player.sendTranslatedChatMessage("wand.wrongmode");
@@ -35,10 +33,10 @@ public class ItemWandSpawner
             float f1 = player.xRotO + (player.xRot - player.xRotO) * f;
             float f2 = player.yRotO + (player.yRot - player.yRotO) * f;
             double posX = player.xo + (player.x - player.xo) * (double) f;
-            float yOff = player instanceof EntityPlayerMP ? player.getHeightOffset() : 0;
+            float yOff = player instanceof ServerPlayer ? player.getHeightOffset() : 0;
             double posY = (player.yo + (player.y - player.yo)) + yOff;
             double posZ = player.zo + (player.z - player.zo) * (double) f;
-            Vec3d vec3d = Vec3d.createVector(posX, posY, posZ);
+            Vec3 vec3 = Vec3.getTempVec3(posX, posY, posZ);
             float f3 = MathHelper.cos(-f2 * 0.01745329F - MathHelper.PI);
             float f4 = MathHelper.sin(-f2 * 0.01745329F - MathHelper.PI);
             float f5 = -MathHelper.cos(-f1 * 0.01745329F);
@@ -47,12 +45,12 @@ public class ItemWandSpawner
             float f8 = f6;
             float f9 = f3 * f5;
             double reachDistance = player.getGamemode().getBlockReachDistance();
-            Vec3d vec3d1 = vec3d.addVector((double) f7 * reachDistance, (double) f8 * reachDistance, (double) f9 * reachDistance);
-            HitResult rayTraceResult = world.checkBlockCollisionBetweenPoints(vec3d, vec3d1, false);
+            Vec3 vec31 = vec3.add((double) f7 * reachDistance, (double) f8 * reachDistance, (double) f9 * reachDistance);
+            HitResult rayTraceResult = world.checkBlockCollisionBetweenPoints(vec3, vec31, false);
 
             if (rayTraceResult != null){
                 if (!world.isClientSide){
-                    spawnEntity(itemstack, world, rayTraceResult.location.xCoord, rayTraceResult.location.yCoord, rayTraceResult.location.zCoord);
+                    spawnEntity(itemstack, world, rayTraceResult.location.x, rayTraceResult.location.y, rayTraceResult.location.z);
                 }
                 return itemstack;
             }
@@ -75,8 +73,8 @@ public class ItemWandSpawner
         if (entity != null){
             entity.setPos(x, y, z);
             entity.spawnInit();
-            if (itemStack.hasCustomName() && entity instanceof EntityLiving){
-                ((EntityLiving)entity).setNickname(itemStack.getCustomName());
+            if (itemStack.hasCustomName() && entity instanceof Mob){
+                ((Mob)entity).setNickname(itemStack.getCustomName());
             }
             world.entityJoinedWorld(entity);
         }
diff --git a/src/main/java/net/minecraft/core/item/ItemToolShears.java b/src/main/java/net/minecraft/core/item/ToolShearsItem.java
similarity index 59%
rename from src/main/java/net/minecraft/core/item/ItemToolShears.java
rename to src/main/java/net/minecraft/core/item/ToolShearsItem.java
index cf978f6cf..811380791 100644
--- a/src/main/java/net/minecraft/core/item/ItemToolShears.java
+++ b/src/main/java/net/minecraft/core/item/ToolShearsItem.java
@@ -3,30 +3,31 @@ package net.minecraft.core.item;
 
 // Referenced classes of package net.minecraft.src:
 //            Item, Block, BlockLeaves, ItemStack, 
-//            EntityLiving
+//            Mob
 
+import net.minecraft.core.block.BaseLeavesBlock;
 import net.minecraft.core.block.tag.BlockTags;
-import net.minecraft.core.entity.EntityLiving;
+import net.minecraft.core.entity.Mob;
 import net.minecraft.core.item.material.ToolMaterial;
 import net.minecraft.core.block.Block;
-import net.minecraft.core.block.BlockLeavesBase;
+import net.minecraft.core.block.Blocks;
 
-public class ItemToolShears extends Item
+public class ToolShearsItem extends Item
 {
 
-    public ItemToolShears(String name, int id, ToolMaterial material)
+    public ToolShearsItem(String name, String namespaceId, int id, ToolMaterial material)
     {
-        super(name, id);
+        super(name, namespaceId, id);
         setMaxStackSize(1);
         setMaxDamage(material.getDurability());
     }
     
-    public void onBlockSheared(EntityLiving entity, ItemStack itemStack) {
+    public void onBlockSheared(Mob entity, ItemStack itemStack) {
     	itemStack.damageItem(1, entity);
     }
 
     @Override
-    public boolean canHarvestBlock(EntityLiving entityLiving, ItemStack itemStack, Block block)
+    public boolean canHarvestBlock(Mob entityLiving, ItemStack itemStack, Block block)
     {
         return block.hasTag(BlockTags.MINEABLE_BY_SHEARS);
     }
@@ -34,7 +35,7 @@ public class ItemToolShears extends Item
     @Override
     public float getStrVsBlock(ItemStack itemstack, Block block)
     {
-        if(block.id == Block.cobweb.id || block instanceof BlockLeavesBase)
+        if(block.id == Blocks.COBWEB.id || block instanceof BaseLeavesBlock)
         {
             return 15F;
         }
diff --git a/src/main/java/net/minecraft/core/item/UnloadedHandCannonItem.java b/src/main/java/net/minecraft/core/item/UnloadedHandCannonItem.java
new file mode 100644
index 000000000..82c8d0a37
--- /dev/null
+++ b/src/main/java/net/minecraft/core/item/UnloadedHandCannonItem.java
@@ -0,0 +1,30 @@
+package net.minecraft.core.item;
+
+// Referenced classes of package net.minecraft.src:
+//            Item, Player, InventoryPlayer, World,
+//            ArrowProjectile, ItemStack
+
+import net.minecraft.core.entity.player.Player;
+import net.minecraft.core.world.World;
+
+public class UnloadedHandCannonItem extends Item
+{
+
+    public UnloadedHandCannonItem(String name, String namespaceId, int id)
+    {
+        super(name, namespaceId, id);
+        setMaxDamage(100);
+        maxStackSize = 1;
+    }
+
+    @Override
+    public ItemStack onUseItem(ItemStack itemstack, World world, Player entityplayer)
+    {
+        if (entityplayer.inventory.consumeInventoryItem(Items.AMMO_CHARGE_EXPLOSIVE.id))
+        {
+            world.playSoundAtEntity(entityplayer, entityplayer, "random.click", 1.0F, 1.9F / (itemRand.nextFloat() * 0.2F + 0.4F));
+            return new ItemStack(Items.HANDCANNON_LOADED, 1, itemstack.getMetadata(), itemstack.getData());
+        }
+        return itemstack;
+    }
+}
diff --git a/src/main/java/net/minecraft/core/item/block/ItemBlockAlgae.java b/src/main/java/net/minecraft/core/item/block/AlgaeBlockItem.java
similarity index 66%
rename from src/main/java/net/minecraft/core/item/block/ItemBlockAlgae.java
rename to src/main/java/net/minecraft/core/item/block/AlgaeBlockItem.java
index fa0e47a1a..95871617b 100644
--- a/src/main/java/net/minecraft/core/item/block/ItemBlockAlgae.java
+++ b/src/main/java/net/minecraft/core/item/block/AlgaeBlockItem.java
@@ -1,23 +1,24 @@
 package net.minecraft.core.item.block;
 // Referenced classes of package net.minecraft.src:
-//            Item, EntityPlayer, Vec3D, MathHelper, 
+//            Item, Player, Vec3D, MathHelper,
 //            World, MovingObjectPosition, EnumMovingObjectType, Block, 
-//            EntityBoat, ItemStack
+//            BoatEntity, ItemStack
 
-import net.minecraft.core.HitResult;
+import net.minecraft.core.entity.player.Player;
+import net.minecraft.core.util.phys.HitResult;
 import net.minecraft.core.block.Block;
-import net.minecraft.core.entity.player.EntityPlayer;
+import net.minecraft.core.block.Blocks;
 import net.minecraft.core.enums.EnumBlockSoundEffectType;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.util.helper.Side;
-import net.minecraft.core.util.phys.Vec3d;
+import net.minecraft.core.util.phys.Vec3;
 import net.minecraft.core.world.World;
 
-public class ItemBlockAlgae extends ItemBlock
+public class AlgaeBlockItem extends BlockItem
 {
 
-    public ItemBlockAlgae(Block block)
+    public AlgaeBlockItem(Block block)
     {
         super(block);
         setMaxDamage(0);
@@ -25,13 +26,13 @@ public class ItemBlockAlgae extends ItemBlock
     }
     
     @Override
-    public boolean onUseItemOnBlock(ItemStack itemstack, EntityPlayer entityplayer, World world, int blockX, int blockY, int blockZ, Side side, double xPlaced, double yPlaced)
+    public boolean onUseItemOnBlock(ItemStack itemstack, Player entityplayer, World world, int blockX, int blockY, int blockZ, Side side, double xPlaced, double yPlaced)
     {
     	return false;
     }
     
     @Override
-    public ItemStack onUseItem(ItemStack itemstack, World world, EntityPlayer entityplayer)
+    public ItemStack onUseItem(ItemStack itemstack, World world, Player entityplayer)
     {
         float f = 1.0F;
         float f1 = entityplayer.xRotO + (entityplayer.xRot - entityplayer.xRotO) * f;
@@ -39,17 +40,17 @@ public class ItemBlockAlgae extends ItemBlock
         double d = entityplayer.xo + (entityplayer.x - entityplayer.xo) * (double)f;
         double d1 = (entityplayer.yo + (entityplayer.y - entityplayer.yo) * (double)f + 1.62D) - (double)entityplayer.heightOffset;
         double d2 = entityplayer.zo + (entityplayer.z - entityplayer.zo) * (double)f;
-        Vec3d vec3d = Vec3d.createVector(d, d1, d2);
-        float f3 = MathHelper.cos(-f2 * 0.01745329F - 3.141593F);
-        float f4 = MathHelper.sin(-f2 * 0.01745329F - 3.141593F);
+        Vec3 vec3 = Vec3.getTempVec3(d, d1, d2);
+        float f3 = MathHelper.cos(-f2 * 0.01745329F - MathHelper.PI);
+        float f4 = MathHelper.sin(-f2 * 0.01745329F - MathHelper.PI);
         float f5 = -MathHelper.cos(-f1 * 0.01745329F);
         float f6 = MathHelper.sin(-f1 * 0.01745329F);
         float f7 = f4 * f5;
         float f8 = f6;
         float f9 = f3 * f5;
         double d3 = 5D;
-        Vec3d vec3d1 = vec3d.addVector((double)f7 * d3, (double)f8 * d3, (double)f9 * d3);
-        HitResult movingobjectposition = world.checkBlockCollisionBetweenPoints(vec3d, vec3d1, true);
+        Vec3 vec31 = vec3.add((double)f7 * d3, (double)f8 * d3, (double)f9 * d3);
+        HitResult movingobjectposition = world.checkBlockCollisionBetweenPoints(vec3, vec31, true);
         if(movingobjectposition == null)
         {
             return itemstack;
@@ -60,7 +61,7 @@ public class ItemBlockAlgae extends ItemBlock
             int j = movingobjectposition.y;
             int k = movingobjectposition.z;
 
-            if(world.getBlockId(i, j, k) == Block.fluidWaterStill.id)
+            if(world.getBlockId(i, j, k) == Blocks.FLUID_WATER_STILL.id)
             {
                 j++;
             }
@@ -70,10 +71,10 @@ public class ItemBlockAlgae extends ItemBlock
 
             if(world.getBlockId(i, j, k) != 0)
                 return itemstack;
-            Block block = Block.blocksList[Block.algae.id];
-            if(itemstack.consumeItem(entityplayer) && world.setBlockAndMetadataWithNotify(i, j, k, Block.algae.id, 0))
+            Block block = Block.blocksList[Blocks.ALGAE.id];
+            if(itemstack.consumeItem(entityplayer) && world.setBlockAndMetadataWithNotify(i, j, k, Blocks.ALGAE.id, 0))
             {
-                block.onBlockPlaced(world, i, j, k, null, entityplayer, 0.0);
+                block.onBlockPlacedByMob(world, i, j, k, null, entityplayer, 0.0);
                 world.playBlockSoundEffect(entityplayer, i + 0.5F, j + 0.5F, k + 0.5F, block, EnumBlockSoundEffectType.PLACE);
                 entityplayer.swingItem();
             }
diff --git a/src/main/java/net/minecraft/core/item/block/ItemBlock.java b/src/main/java/net/minecraft/core/item/block/BlockItem.java
similarity index 79%
rename from src/main/java/net/minecraft/core/item/block/ItemBlock.java
rename to src/main/java/net/minecraft/core/item/block/BlockItem.java
index 6489ee451..d91d457c5 100644
--- a/src/main/java/net/minecraft/core/item/block/ItemBlock.java
+++ b/src/main/java/net/minecraft/core/item/block/BlockItem.java
@@ -1,8 +1,8 @@
 package net.minecraft.core.item.block;
 
 import net.minecraft.core.block.Block;
-import net.minecraft.core.block.BlockFluid;
-import net.minecraft.core.entity.player.EntityPlayer;
+import net.minecraft.core.block.FluidBlock;
+import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.enums.EnumBlockSoundEffectType;
 import net.minecraft.core.item.Item;
 import net.minecraft.core.item.ItemStack;
@@ -13,16 +13,16 @@ import static net.minecraft.core.world.LevelListener.EVENT_BLOCK_BREAK;
 
 // Referenced classes of package net.minecraft.src:
 //            Item, Block, World, ItemStack, 
-//            Material, StepSound, EntityPlayer
+//            Material, StepSound, Player
 
-public class ItemBlock extends Item
+public class BlockItem extends Item
 {
 
     protected int blockID;
 
-    public ItemBlock(Block block)
+    public BlockItem(Block block)
     {
-        super(block.id);
+        super(block.namespaceID, block.id);
         blockID = block.id;
         setKey(block.getKey());
     }
@@ -33,7 +33,7 @@ public class ItemBlock extends Item
     }
 
     @Override
-	public boolean onUseItemOnBlock(ItemStack stack, EntityPlayer player, World world, int blockX, int blockY, int blockZ, Side side, double xPlaced, double yPlaced) {
+	public boolean onUseItemOnBlock(ItemStack stack, Player player, World world, int blockX, int blockY, int blockZ, Side side, double xPlaced, double yPlaced) {
 		if(stack.stackSize <= 0) {
 			return false;
 		}
@@ -43,7 +43,7 @@ public class ItemBlock extends Item
 			blockZ += side.getOffsetZ();
 		}
         Block currentBlock = world.getBlock(blockX, blockY, blockZ);
-        boolean placedInside = currentBlock != null && !(currentBlock instanceof BlockFluid);
+        boolean placedInside = currentBlock != null && !(currentBlock instanceof FluidBlock);
 
         if(blockY < 0 || blockY >= world.getHeightBlocks()) {
         	return false;
@@ -54,7 +54,7 @@ public class ItemBlock extends Item
                 world.playSoundEffect(EVENT_BLOCK_BREAK, blockX, blockY, blockZ, world.getBlockId(blockX, blockY, blockZ));
             }
 			if(world.setBlockAndMetadataWithNotify(blockX, blockY, blockZ, blockID, getPlacedBlockMetadata(stack.getMetadata()))) {
-				block.onBlockPlaced(world, blockX, blockY, blockZ, side, player, yPlaced);
+				block.onBlockPlacedByMob(world, blockX, blockY, blockZ, side, player, yPlaced);
 				world.playBlockSoundEffect(player, blockX + 0.5F, blockY + 0.5F, blockZ + 0.5F, block, EnumBlockSoundEffectType.PLACE);
 
 			}
diff --git a/src/main/java/net/minecraft/core/item/block/BlockItemStairsPainted.java b/src/main/java/net/minecraft/core/item/block/BlockItemStairsPainted.java
new file mode 100644
index 000000000..0e8b4d768
--- /dev/null
+++ b/src/main/java/net/minecraft/core/item/block/BlockItemStairsPainted.java
@@ -0,0 +1,27 @@
+package net.minecraft.core.item.block;
+
+import net.minecraft.core.block.Block;
+import net.minecraft.core.item.ItemStack;
+import net.minecraft.core.util.helper.DyeColor;
+
+public class BlockItemStairsPainted extends BlockItem
+{
+
+    public BlockItemStairsPainted(Block block)
+    {
+        super(block);
+        setMaxDamage(0);
+        setHasSubtypes(true);
+    }
+
+    @Override
+    public int getPlacedBlockMetadata(int i)
+    {
+        return i;
+    }
+
+    @Override
+    public String getLanguageKey(ItemStack itemstack) {
+        return super.getKey() + "." + DyeColor.colorFromBlockMeta((itemstack.getMetadata() & 0xF0) >> 4).colorID;
+    }
+}
diff --git a/src/main/java/net/minecraft/core/item/block/ItemBlockLadder.java b/src/main/java/net/minecraft/core/item/block/LadderBlockItem.java
similarity index 54%
rename from src/main/java/net/minecraft/core/item/block/ItemBlockLadder.java
rename to src/main/java/net/minecraft/core/item/block/LadderBlockItem.java
index 4fde46643..f0e9a6904 100644
--- a/src/main/java/net/minecraft/core/item/block/ItemBlockLadder.java
+++ b/src/main/java/net/minecraft/core/item/block/LadderBlockItem.java
@@ -1,9 +1,9 @@
 package net.minecraft.core.item.block;
 
 import net.minecraft.core.block.Block;
-import net.minecraft.core.block.BlockFluid;
-import net.minecraft.core.block.BlockLadder;
-import net.minecraft.core.entity.player.EntityPlayer;
+import net.minecraft.core.block.FluidBlock;
+import net.minecraft.core.block.LadderBlock;
+import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.enums.EnumBlockSoundEffectType;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.util.helper.Side;
@@ -11,25 +11,25 @@ import net.minecraft.core.world.World;
 
 import static net.minecraft.core.world.LevelListener.EVENT_BLOCK_BREAK;
 
-public class ItemBlockLadder extends ItemBlock {
+public class LadderBlockItem extends BlockItem {
 
-	private BlockLadder blockLadder;
+	private LadderBlock ladderBlock;
 	
-	public ItemBlockLadder(BlockLadder block) {
+	public LadderBlockItem(LadderBlock block) {
 		super(block);
 		
-		this.blockLadder = block;
+		this.ladderBlock = block;
 	}
 	
 	@Override
-	public boolean onUseItemOnBlock(ItemStack stack, EntityPlayer player, World world, int x, int y, int z, Side side, double xPlaced, double yPlaced) {
+	public boolean onUseItemOnBlock(ItemStack stack, Player player, World world, int x, int y, int z, Side side, double xPlaced, double yPlaced) {
 		Block clickedBlock = world.getBlock(x, y, z);
 		
-		if(clickedBlock == blockLadder && !player.isSneaking()) {
-			Side clickedLadderSide = blockLadder.getSideFromMeta(world.getBlockMetadata(x, y, z));
-			while(world.getBlock(x, y, z) == blockLadder && blockLadder.getSideFromMeta(world.getBlockMetadata(x, y, z)) == clickedLadderSide) y--;
-			int meta = blockLadder.getMetaForSide(clickedLadderSide);
-			if(blockLadder.canExistAt(world, x, y, z, meta)) {
+		if(clickedBlock == ladderBlock && !player.isSneaking()) {
+			Side clickedLadderSide = ladderBlock.getSideFromMeta(world.getBlockMetadata(x, y, z));
+			while(world.getBlock(x, y, z) == ladderBlock && ladderBlock.getSideFromMeta(world.getBlockMetadata(x, y, z)) == clickedLadderSide) y--;
+			int meta = ladderBlock.getMetaForSide(clickedLadderSide);
+			if(ladderBlock.canExistAt(world, x, y, z, meta)) {
 				return placeBlock(world, x, y, z, meta, player, stack, clickedLadderSide, 0.5);
 			}
 			
@@ -42,28 +42,28 @@ public class ItemBlockLadder extends ItemBlock {
 			z += side.getOffsetZ();
 		}
 		
-		Side sideForPlacement = blockLadder.getSideForPlacement(world, x, y, z, side);
+		Side sideForPlacement = ladderBlock.getSideForPlacement(world, x, y, z, side);
 		if(sideForPlacement == null) {
 			return false;
 		}
 		
-		int meta = blockLadder.getMetaForSide(sideForPlacement);
-		if(blockLadder.canExistAt(world, x, y, z, meta)) {
+		int meta = ladderBlock.getMetaForSide(sideForPlacement);
+		if(ladderBlock.canExistAt(world, x, y, z, meta)) {
 			return placeBlock(world, x, y, z, meta, player, stack, sideForPlacement, yPlaced);
 		}
 		
 		return false;
 	}
 	
-	public boolean placeBlock(World world, int x, int y, int z, int meta, EntityPlayer player, ItemStack stack, Side side, double sideHeight) {
+	public boolean placeBlock(World world, int x, int y, int z, int meta, Player player, ItemStack stack, Side side, double sideHeight) {
 		Block currentBlock = world.getBlock(x, y, z);
 		if(world.canPlaceInsideBlock(x, y, z) && world.canBlockBePlacedAt(blockID, x, y, z, false, side) && stack.consumeItem(player)) {
-			if (currentBlock != null && !(currentBlock instanceof BlockFluid) && !world.isClientSide){
+			if (currentBlock != null && !(currentBlock instanceof FluidBlock) && !world.isClientSide){
 				world.playSoundEffect(EVENT_BLOCK_BREAK, x, y, z, world.getBlockId(x, y, z));
 			}
 			if(world.setBlockAndMetadataWithNotify(x, y, z, blockID, meta)) {
-				Block.getBlock(blockID).onBlockPlaced(world, x, y, z, side, player, sideHeight);
-				world.playBlockSoundEffect(player, x + 0.5f, y + 0.5f, z + 0.5f, blockLadder, EnumBlockSoundEffectType.PLACE);
+				Block.getBlock(blockID).onBlockPlacedByMob(world, x, y, z, side, player, sideHeight);
+				world.playBlockSoundEffect(player, x + 0.5f, y + 0.5f, z + 0.5f, ladderBlock, EnumBlockSoundEffectType.PLACE);
 				return true;
 			}
 		}
diff --git a/src/main/java/net/minecraft/core/item/block/ItemBlockLamp.java b/src/main/java/net/minecraft/core/item/block/LampBlockItem.java
similarity index 57%
rename from src/main/java/net/minecraft/core/item/block/ItemBlockLamp.java
rename to src/main/java/net/minecraft/core/item/block/LampBlockItem.java
index 7cd68a24a..7ae72fe8b 100644
--- a/src/main/java/net/minecraft/core/item/block/ItemBlockLamp.java
+++ b/src/main/java/net/minecraft/core/item/block/LampBlockItem.java
@@ -1,14 +1,14 @@
 package net.minecraft.core.item.block;
 
 import net.minecraft.core.block.Block;
-import net.minecraft.core.block.BlockLamp;
-import net.minecraft.core.item.ItemDye;
+import net.minecraft.core.block.LampBlock;
 import net.minecraft.core.item.ItemStack;
+import net.minecraft.core.util.helper.DyeColor;
 
-public class ItemBlockLamp extends ItemBlock
+public class LampBlockItem extends BlockItem
 {
 
-    public ItemBlockLamp(Block block)
+    public LampBlockItem(Block block)
     {
         super(block);
         setMaxDamage(0);
@@ -24,6 +24,6 @@ public class ItemBlockLamp extends ItemBlock
     @Override
     public String getLanguageKey(ItemStack itemstack)
     {
-        return super.getKey() + "." + ItemDye.dyeColors[BlockLamp.getMetadataForColour(itemstack.getMetadata())];
+        return super.getKey() + "." + DyeColor.colorFromBlockMeta(itemstack.getMetadata()).colorID;
     }
 }
\ No newline at end of file
diff --git a/src/main/java/net/minecraft/core/item/block/ItemBlockLayer.java b/src/main/java/net/minecraft/core/item/block/LayerBlockItem.java
similarity index 78%
rename from src/main/java/net/minecraft/core/item/block/ItemBlockLayer.java
rename to src/main/java/net/minecraft/core/item/block/LayerBlockItem.java
index 844e1d42b..3ccbb592f 100644
--- a/src/main/java/net/minecraft/core/item/block/ItemBlockLayer.java
+++ b/src/main/java/net/minecraft/core/item/block/LayerBlockItem.java
@@ -2,14 +2,13 @@ package net.minecraft.core.item.block;
 
 // Referenced classes of package net.minecraft.src:
 //            Item, Block, World, ItemStack,
-//            Material, StepSound, EntityPlayer
+//            Material, StepSound, Player
 
-import net.minecraft.core.Global;
 import net.minecraft.core.block.Block;
-import net.minecraft.core.block.BlockFluid;
-import net.minecraft.core.block.BlockLayerBase;
+import net.minecraft.core.block.FluidBlock;
+import net.minecraft.core.block.BaseLayerBlock;
 import net.minecraft.core.block.tag.BlockTags;
-import net.minecraft.core.entity.player.EntityPlayer;
+import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.enums.EnumBlockSoundEffectType;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.util.helper.Side;
@@ -19,15 +18,15 @@ import net.minecraft.core.world.World;
 import static net.minecraft.core.world.LevelListener.EVENT_BLOCK_BREAK;
 
 
-public class ItemBlockLayer extends ItemBlock
+public class LayerBlockItem extends BlockItem
 {
-	public ItemBlockLayer(Block block)
+	public LayerBlockItem(Block block)
 	{
 		super(block);
 	}
 
 	@Override
-	public boolean onUseItemOnBlock(final ItemStack itemstack, final EntityPlayer entityplayer, final World world, int blockX, int blockY, int blockZ, final Side side, double xPlaced, final double yPlaced)
+	public boolean onUseItemOnBlock(final ItemStack itemstack, final Player entityplayer, final World world, int blockX, int blockY, int blockZ, final Side side, double xPlaced, final double yPlaced)
 	{
 		int id = world.getBlockId(blockX, blockY, blockZ);
 		int meta = world.getBlockMetadata(blockX, blockY, blockZ);
@@ -49,11 +48,11 @@ public class ItemBlockLayer extends ItemBlock
 		if (id == blockID && side == Side.TOP)
 		{
 
-			final BlockLayerBase blockLayer = (BlockLayerBase) Block.blocksList[blockID];
+			final BaseLayerBlock blockLayer = (BaseLayerBlock) Block.blocksList[blockID];
 
 			final int newMeta = meta + 1;
 
-			final AABB bbBox = AABB.getBoundingBoxFromPool(blockX, blockY, blockZ, blockX + 1f, blockY + (2 * (newMeta + 1)) / 16.0f, blockZ + 1f);
+			final AABB bbBox = AABB.getTemporaryBB(blockX, blockY, blockZ, blockX + 1f, blockY + (2 * (newMeta + 1)) / 16.0f, blockZ + 1f);
 			if (!world.checkIfAABBIsClear(bbBox))
 			{
 				return false;
@@ -94,11 +93,11 @@ public class ItemBlockLayer extends ItemBlock
 		if (id == blockID)
 		{
 
-			final BlockLayerBase blockLayer = (BlockLayerBase) Block.blocksList[blockID];
+			final BaseLayerBlock blockLayer = (BaseLayerBlock) Block.blocksList[blockID];
 
 			final int newMeta = meta + 1;
 
-			final AABB bbBox = AABB.getBoundingBoxFromPool(blockX, blockY, blockZ, blockX + 1f, blockY + (2 * (newMeta + 1)) / 16.0f, blockZ + 1f);
+			final AABB bbBox = AABB.getTemporaryBB(blockX, blockY, blockZ, blockX + 1f, blockY + (2 * (newMeta + 1)) / 16.0f, blockZ + 1f);
 			if (!world.checkIfAABBIsClear(bbBox))
 			{
 				return false;
@@ -129,13 +128,13 @@ public class ItemBlockLayer extends ItemBlock
 		{
 			final Block block = Block.blocksList[blockID];
 			Block currentBlock = world.getBlock(blockX, blockY, blockZ);
-			boolean placedInside = currentBlock != null && !(currentBlock instanceof BlockFluid);
+			boolean placedInside = currentBlock != null && !(currentBlock instanceof FluidBlock);
 			if (world.setBlockAndMetadataWithNotify(blockX, blockY, blockZ, blockID, getPlacedBlockMetadata(itemstack.getMetadata())))
 			{
 				if (placedInside && !world.isClientSide){
 					world.playSoundEffect(EVENT_BLOCK_BREAK, blockX, blockY, blockZ, currentBlock.id);
 				}
-				Block.blocksList[blockID].onBlockPlaced(world, blockX, blockY, blockZ, null, entityplayer, yPlaced);
+				Block.blocksList[blockID].onBlockPlacedByMob(world, blockX, blockY, blockZ, null, entityplayer, yPlaced);
 				world.playBlockSoundEffect(entityplayer, blockX + 0.5F, blockY + 0.5F, blockZ + 0.5F, block, EnumBlockSoundEffectType.PLACE);
 				itemstack.consumeItem(entityplayer);
 			}
diff --git a/src/main/java/net/minecraft/core/item/block/LeavesBlockItem.java b/src/main/java/net/minecraft/core/item/block/LeavesBlockItem.java
new file mode 100644
index 000000000..ac574477f
--- /dev/null
+++ b/src/main/java/net/minecraft/core/item/block/LeavesBlockItem.java
@@ -0,0 +1,18 @@
+package net.minecraft.core.item.block;
+
+import net.minecraft.core.block.BaseLeavesBlock;
+import net.minecraft.core.block.Block;
+
+public class LeavesBlockItem extends BlockItem
+{
+    public LeavesBlockItem(Block block)
+    {
+        super(block);
+    }
+
+    @Override
+    public int getPlacedBlockMetadata(int i)
+    {
+        return BaseLeavesBlock.setPermanent(super.getPlacedBlockMetadata(i), true);
+    }
+}
